"""
Spectre and Meltdown tutorial

Qui Hao (Frank) Yu and Haseeb Choudhary

This exercise is to simulate the spectre vulnerability in a much simpler
version.

=====

Memory size = 1024 (bytes)
Cache size = 256 (lines) 1 byte each

Cache implementation:

First in first out queue with priority
If some data is accessed again it's priority increases
The priority is used for eviction

e.g. if data is about to be evicted but is accessed
it's priority increases and it will be moved to the back
of the queue.

Access time of memory is 0.2 seconds slower than access time from the
cache. 

=============
machine class
=============

This is used to simulate an actual machine, running different processes
and with on static area reserved for kernel memory. Each process is assigned
a chunk of static memory of 256 bytes. Once memory is full no new proccesses
can be created. The cache of the machine is updated each time memory is read
or accessed.

Accessed - just moving/storing data around, only success/error codes returned

Read - data returned to the user

-- methods --

- flush(): flushes cache
- access_memory(store_address, load_address[, data]): performs the following
operation memory[store_address + memory[load_address]] = data. Stores this in
the cache as well.
- read_memory(read_address): returns the data stored at read_address, this
address **must be in your own process' address space**. Stores the memory
access in the cache as well.
- create_process(name): creates a process on the machine with the provided
name. Allocates 256 bytes on memory on the machine, the process class is
defined below.

*** NOTE ***
The victim process already exists in memory this is to simulate that the victim
will already be running a process on the machine you wish to deploy this
vulnerability onto. The address space of the victim process is from 256 - 512.
You need to find where the secret data is within this address space and print
it in human readable characters.

=============
process class
=============

This class is used to simulate an actual process running on the machine class
as described above.

Each process is allocated a static piece of memory when it is initialized
of 256 bytes. Each process has a name and a chunk of memory it can use to
store/read data to/from.

-- methods --

- store_data(address, value): store the value "value" in the memory location
"address". "address" must be in your processes address space. 
- get_data(address): get the data from this memory location from this
processes' address space
- get_base_addr(): get the base address of this process
- get_size(): get the size of the address space for this process
"""
import machine
from machine import *

if __name__ == "__main__":
    m = machine()

    # your attacking process
    process = m.create_process("attacker")

    # "array" data type base address in your address space
    array_base = process.get_base_addr() + 32

    # the min and max characters' ASCII values, the possible values
    # read from victim address space
    min_char, max_char = ord('a'), ord('z')+1

    # add your attack code below
